Package org.italiangrid.voms

# Interface VOMSAttribute

All Known Implementing Classes:
  `VOMSAttributesImpl`

public interface VOMSAttribute
The VOMS attributes information. This interface provides access to all the information available in a VOMS attribute certificate.

Author:
  Andrea Ceccanti

## Method Summary

Modifier and Type
Method
Description
`X509Certificate[]`
`getAACertificates()`
This method returns the certificate chain of the VOMS Attribute Authority (AA) that signed this `VOMSAttribute`.
`List<String>`
`getFQANs()`
This method returns the list of signed Fully Qualified Attribute Names (FQANs) in this `VOMSAttribute`.
`List<VOMSGenericAttribute>`
`getGenericAttributes()`
This method returns the list of VOMS Generic attributes in this `VOMSAttribute`.
`X500Principal`
`getHolder()`
This method returns the subject (as an `X500Principal`) of the holder of these VOMS attributes
`BigInteger`
`getHolderSerialNumber()`
This method returns the holder certificate serial number
`String`
`getHost()`
This method returns the host where the VOMS Attribute Authority (AA) that signed these attribute lives
`X500Principal`
`getIssuer()`
This method returns the subject of the VOMS Attribute Authority that signed these attributes.
`Date`
`getNotAfter()`
This method returns the attributes' validity end time
`Date`
`getNotBefore()`
This method returns the attributes' validity start time
`int`
`getPort()`
This method returns the port on which the VOMS Attribute Authority (AA) that signed these attributes listens for requests.
`String`
`getPrimaryFQAN()`
This method returns the primary FQAN (the first in the list returned by `getFQANs()`) in this `VOMSAttribute`.
`byte[]`
`getSignature()`
This method returns the signature on the VOMS attribute certificate as a byte array.
`List<String>`
`getTargets()`
This method returns the list of targets defined for this `VOMSAttribute`.
`String`
`getVO()`
This method returns the name of the VO this VOMS attributes are about
`org.bouncycastle.cert.X509AttributeCertificateHolder`
`getVOMSAC()`
This method returns the underlying VOMS Attribute certificate object.
`boolean`
`isValid()`
This method checks whether the attributes are valid in the current instant of time.
`boolean`
`validAt(Date time)`
This method checks whether the attributes are valid in a given time passed as argument.

## Method Details

### getVO

String getVO()
This method returns the name of the VO this VOMS attributes are about

Returns:
  The name of the VO this VOMS attributes are about

### getHost

String getHost()
This method returns the host where the VOMS Attribute Authority (AA) that signed these attribute lives

Returns:
  The name of the host where the VOMS AA that signed these attributes lives

### getPort

int getPort()
This method returns the port on which the VOMS Attribute Authority (AA) that signed these attributes listens for requests.

Returns:
  The port on which the VOMS AA that signed these attributes listens for requests

### getHolder

X500Principal getHolder()
This method returns the subject (as an `X500Principal`) of the holder of these VOMS attributes

Returns:
  The subject of the holder of these VOMS attributes

### getHolderSerialNumber

BigInteger getHolderSerialNumber()
This method returns the holder certificate serial number

Returns:
  The serial number of the holder certificate

### getIssuer

X500Principal getIssuer()
This method returns the subject of the VOMS Attribute Authority that signed these attributes.

Returns:
  The subject of the VOMS AA that signed these attributes

### getNotBefore

Date getNotBefore()
This method returns the attributes' validity start time

Returns:
  The attributes' validity start time

### getNotAfter

Date getNotAfter()
This method returns the attributes' validity end time

Returns:
  The attributes' validity end time

### getFQANs

List<String> getFQANs()
This method returns the list of signed Fully Qualified Attribute Names (FQANs) in this `VOMSAttribute`.

Returns:
  The `List` of VOMS fully qualified attribute names

### getPrimaryFQAN

String getPrimaryFQAN()
This method returns the primary FQAN (the first in the list returned by `getFQANs()`) in this `VOMSAttribute`.

Returns:
  The primary VOMS fully qualified attribute name

### getSignature

byte[] getSignature()
This method returns the signature on the VOMS attribute certificate as a byte array.

Returns:
  The signature of this VOMS attributes

### getGenericAttributes

List<VOMSGenericAttribute> getGenericAttributes()
This method returns the list of VOMS Generic attributes in this `VOMSAttribute`.

Returns:
  The VOMS generic attributes

### getTargets

List<String> getTargets()
This method returns the list of targets defined for this `VOMSAttribute`.

Returns:
  The targets for this VOMS attributes

### getAACertificates

X509Certificate[] getAACertificates()
This method returns the certificate chain of the VOMS Attribute Authority (AA) that signed this `VOMSAttribute`.

Returns:
  The VOMS AA certificate chain

### isValid

boolean isValid()
This method checks whether the attributes are valid in the current instant of time. No validation is performed on the attributes.

Returns:
  `true` if valid, `false` otherwise

### validAt

boolean validAt(Date time)
This method checks whether the attributes are valid in a given time passed as argument. No validation is performed on the attributes.

Parameters:
  `time` - the time used for the validity check
Returns:
  `true` if valid, `false` otherwise

### getVOMSAC

org.bouncycastle.cert.X509AttributeCertificateHolder getVOMSAC()
This method returns the underlying VOMS Attribute certificate object.

Returns:
  the underlying bouncycastle object for the VOMS attribute certificate.